diff --git a/cloudinit/config/cc_mounts.py b/cloudinit/config/cc_mounts.py
index c741c746..7b996295 100644
--- a/cloudinit/config/cc_mounts.py
+++ b/cloudinit/config/cc_mounts.py
@@ -252,8 +252,7 @@ def setup_swapfile(fname, size=None, maxsize=None):
         util.log_time(LOG.debug, msg, func=util.subp,
                       args=[['sh', '-c',
                              ('rm -f "$1" && umask 0066 && '
-                              '{ fallocate -l "${2}M" "$1" || '
-                              'dd if=/dev/zero "of=$1" bs=1M "count=$2"; } && '
+                              'dd if=/dev/zero "of=$1" bs=1M "count=$2" && '
                               'mkswap "$1" || { r=$?; rm -f "$1"; exit $r; }'),
                              'setup_swap', fname, mbsize]])
 