--- 0001-copr.md	2015-12-23 19:26:53.845390827 +0100
+++ 0002-copr.md	2015-12-24 14:37:10.716161945 +0100
@@ -1,23 +1,22 @@
-# Fedora Copr, les dépôts utilisateurs sous Fedora
+# _Fedora Copr_, les dépôts utilisateurs sous _Fedora_
 
-Avec sa philosophie, Fedora ne propose dans ses dépôts officiels que des logiciels libres. Il faut parfois passé par des dépôts tiers pour obtenir des logiciels propriétaires (le support du format mp3, flash player, spotify, etc). Mais il peut arriver que le logiciel que l'on recherche n’existe pas en paquet rpm, il faut alors le compiler à la main. Fedora a trouvé une parade pour cela : Fedora Copr.
+Avec sa philosophie, _Fedora_ ne propose dans ses dépôts officiels que des logiciels libres. Il faut donc parfois passer par des dépôts tiers pour obtenir des logiciels propriétaires, comme, par exemple, le support du format _mp3_, _Flash Player_, ou encore _Spotify_. Toutefois, il peut arriver que le logiciel que l'on recherche n’existe pas en paquet RPM, et il faut alors le compiler manuellement. _Fedora_ a trouvé une parade pour cela : _Fedora Copr_.
 
-Fedora Copr reprend, en partie, le principe du Arch User Repository d'Arch Linux, il s'agit de ici de petits dépôts créés par les utilisateurs, avec des paquets uploadés au format srpm (RPM Source) puis construit avec le build système qu'offre Fedora Copr.
+Le principe de _Fedora Copr_ repose sur de petits dépôts créés par les utilisateurs, contenant des paquets uploadés au format SRPM (RPM Source) et, ensuite, construits au format RPM avec le build system qu'offre _Fedora Copr_.
 
 ## Une offre plus conséquente
-On pourrait rapprocher Fedora Copr du AUR d'Arch Linux mais ce serait omettre un important détail, l'Arch User Repository ne contient aucun paquet, il propose simplement un « annuaire » de scripts permettant, par la suite, de construire le paquet sur son ordinateur. Fedora Copr quant à lui se rapproche un peu des PPAs d'Ubuntu, il propose des paquets RPM prêts à l'emploi. Le système s'articule de la sorte:
-- Un utilisateur construit un paquet source (SRPM) puis l'envoie sur son dépôt Copr pour que le build system fasse son travaille et construise tout seul un RPM fonctionnel.
-Fedora Copr permet donc d'avoir accès à des logiciels non-présents dans les dépôts officiels de Fedora.
-
-## Le Site Web
-L'interface de Fedora Copr est très simple, la page d'accueil montre les paquets récemment construits, ainsi que les nouveaux dépôts créés. Un outil de recherche est également présent pour permettre de rechercher un paquet précis. Si la recherche est fructueuse, plusieurs résultats peuvent apparaître, il s'agit donc de notre paquet, présent dans plusieurs dépôts d'utilisateur. Ensuite, libre à vous de choisir votre dépôt en fonction de la version du logiciel que vous rechercher, vous arrivez sur la page du dépôt, présentant les divers paquets disponibles selon le numéro de distribution. La page nous montre également le dernier build réalisé sur ce dépôt (ce qui peut être intéressant pour déterminer si le dépôt est toujours actif) ainsi qu'un petit encart appelé "Quick Enable" et qui permet, en ligne de commande, d'activer facilement le dépôt Copr avec dnf. Ensuite il ne reste plus qu'à installer le paquet avec la commande dnf install xxx.
-
-## L'intégration à DNF
-L'intégration avec DNF se fait avec le paquet dnf-copr, installé automatiquement sur chaque nouvelle installation Fedora. Comme les PPAs pour Ubuntu, l'activation d'un dépôt Copr viendra modifier le contenu du dossier /etc/yum.repos.d en ajoutant un fichier .repo pour chaque dépôt activé.
-Une fois le dépôt activé, il n'y a pas de commande particulière pour rechercher, installer, supprimer des paquets provenant de Copr: les traditionnelles commandes dnf search, dnf install et dnf remove fonctionne pour l'ensemble des paquets.
+On pourrait rapprocher _Fedora Copr_ à _Arch User Repository_ (_AUR_) d'_Arch Linux_, mais ce serait omettre un important détail : l'_AUR_ ne contient aucun paquet, car il propose simplement un « annuaire » de scripts permettant, par la suite, de construire le paquet sur son ordinateur. _Fedora Copr_, quant à lui, propose des paquets RPM prêts à l'emploi, ce qui le rapproche un peu des _Personal Package Archives_ (_PPA_) d'_Ubuntu_. 
+
+Le système _Fedora Copr_ s'articule donc de la sorte : un utilisateur construit un paquet source (SRPM), et l'envoie ensuite sur son dépôt _Copr_ pour que le build system fasse son travail et construise de lui-même un paquet RPM fonctionnel. _Fedora Copr_ permet donc d'avoir accès à des logiciels non présents dans les dépôts officiels de _Fedora_.
+
+## Le site web
+L'interface de _Fedora Copr_ est très simple. Il se constitue d'une [page d'accueil](https://copr.fedoraproject.org/) montrant les paquets récemment construits, ainsi que les nouveaux dépôts créés. Un outil de recherche est également présent pour permettre la recherche d'un paquet précis. Si celle-ci est fructueuse, plusieurs résultats peuvent apparaître. Ces derniers correspondent au paquet recherché et présent dans plusieurs dépôts d'utilisateurs. Ensuite, suite au choix d'un dépôt (libre à vous de choisir votre dépôt en fonction de la version du logiciel que vous recherchez), la page du dépôt vous présente les divers paquets disponibles selon le numéro de distribution. Cette page nous montre également le dernier build réalisé sur ce dépôt (ce qui peut être intéressant pour déterminer si ce dépôt est toujours actif), ainsi qu'un petit encart, appelé _Quick Enable_, permettant d'activer facilement en ligne de commande le dépôt _Copr_ avec __dnf__. Finalement, il ne reste plus qu'à installer le paquet avec la commande __dnf install xxx__ où __xxx__ est le nom du paquet.
+
+## L'intégration à __dnf__
+L'intégration avec __dnf__ se fait grâce au paquet _dnf-copr_, installé automatiquement sur chaque nouvelle installation de _Fedora_. Similairement aux _PPA_ d'_Ubuntu_, l'activation d'un dépôt _Copr_ viendra modifier le contenu du dossier _/etc/yum.repos.d_ en y ajoutant un fichier _.repo_ pour chaque dépôt activé. Une fois le dépôt activé, il n'y a pas de commande particulière pour rechercher, installer, ou encore supprimer des paquets provenant de _Fedora Copr_ : les traditionnelles commandes __dnf search__, __dnf install__, et __dnf remove__ fonctionnent pour l'ensemble des paquets _Copr_.
 
 ## Savoir construire un SRPM
-L'un des points noirs de Fedora Copr réside dans la construction du .src.rpm afin que le système puisse construire le RPM final. Contrairement à AUR d'Arch Linux la construction d'un paquet src.rpm est assez compliqué.
+L'un des points noirs de _Fedora Copr_ réside dans la construction des paquets SRPM (_.src.rpm_) afin que le système puisse construire le paquet RPM final. Contrairement à _AUR_ d'_Arch Linux_, la construction d'un paquet SRPM est assez compliquée.
 
-## Le Build System
-Une fois votre paquet .src.rpm prêt, que vous avez créer un compte Fedora Copr, créer un dépôt, il vous suffit d'uploader le paquet pour que le build system s'attelle à la construction du paquet RPM. Votre demande est alors mise en attente d'une place disponible pour la construction, une notification vous informera dès que votre paquet est enfin prêt, cela peut prendre du temps selon la charge de travail de Copr au moment où vous uploadez votre paquet.
+## Le build system
+Lorsque votre paquet SRPM est prêt, et que vous avez créé un compte _Fedora Copr_, ainsi qu'un dépôt, il vous suffit alors d'uploader votre paquet pour que le build system s'attelle à la construction du paquet RPM. Votre demande est alors mise en attente d'une place disponible pour la construction. La mise en attende peut prendre du temps, selon la charge de travail de _Copr_ au moment où vous avez uploadé votre paquet. Une notification vous informera dès que votre paquet est prêt !